clear;

%% Nuvem de Pts
theta = linspace(0,1,500);
x = exp(theta).*sin(100*theta);
y = exp(theta).*cos(100*theta);
f = x.^2 + y.^2;
Pi = [x', y'];
figure, scatter(x,y,24,f,'filled');

pause

%% Grid
n = 50;
t = linspace(-3,3,n);
[X,Y] = meshgrid(t);
P = [X(:), Y(:)];

%% Busca
k = 10;
[idx,D] = knnsearch(Pi,P,'k',k);

%% Interpolacao com Shepard
F = zeros(n^2,1);

for i=1:n^2
    fi = f(idx(i,:));
    dist = D(i,:);
    F(i) = shepard(fi,dist);
end

F = reshape(F,[n,n]);
figure, pcolor(X,Y,F);


